unit f_htmlhint;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, rImprovedComps, rHTMLLabel;

type
  THTMLHintForm = class(TForm)
    rHTMLLabel6: TrHTMLLabel;
    mHintText: TrMemoEx;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    eMinW: TrEditNum;
    eMaxW: TrEditNum;
    eLBarW: TrEditNum;
    eLBarIdx: TrEditNum;
    btFont: TButton;
    FontDialog1: TFontDialog;
    pTest: TPanel;
    btAddImage: TButton;
    chPlainText: TCheckBox;
    Label6: TLabel;
    Label7: TLabel;
    eMinH: TrEditNum;
    Label8: TLabel;
    eMaxH: TrEditNum;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    eRBarW: TrEditNum;
    eRBarIdx: TrEditNum;
    Label12: TLabel;
    procedure mHintTextChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btFontClick(Sender: TObject);
    procedure btAddImageClick(Sender: TObject);
  private
    procedure RefHint;
  public
  end;

var
  HTMLHintForm: THTMLHintForm;

implementation

uses rtool, f_main, RosiCompGlobalCfg;

{$R *.dfm}

procedure THTMLHintForm.btFontClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(self.btFont.Font);
  if FontDialog1.Execute then
  begin
    btFont.Font.Assign(FontDialog1.Font);
    RefHint;
  end;
end;

procedure THTMLHintForm.btAddImageClick(Sender: TObject);
begin
  Main.rHTMLHint1.HintImage.LoadFromFile(GetAppDir + 'Petals.jpg');
  self.mHintText.Lines.Add(RosiCompGlobalCfg.rHTMLHintImageTag);
end;

procedure THTMLHintForm.FormShow(Sender: TObject);
begin
  RefHint;
end;

procedure THTMLHintForm.RefHint;
begin
  pTest.Hint:=mHintText.Lines.Text;
  Main.rHTMLHint1.MinWidth:=self.eMinW.AsInteger;
  Main.rHTMLHint1.MaxWidth:=self.eMaxW.AsInteger;
  Main.rHTMLHint1.MinHeight:=self.eMinH.AsInteger;
  Main.rHTMLHint1.MaxHeight:=self.eMaxH.AsInteger;

  Main.rHTMLHint1.LeftBarWidth:=self.eLBarW.AsInteger;
  Main.rHTMLHint1.LeftBarImageIndex:=self.eLBarIdx.AsInteger;
  Main.rHTMLHint1.RightBarWidth:=self.eRBarW.AsInteger;
  Main.rHTMLHint1.RightBarImageIndex:=self.eRBarIdx.AsInteger;

  Main.rHTMLHint1.HintFont.Assign(self.btFont.Font);
  Main.rHTMLHint1.HintPlainText:=self.chPlainText.Checked;
end;

procedure THTMLHintForm.mHintTextChange(Sender: TObject);
begin
  if self.Visible then
    RefHint;
end;

end.
