unit f_rdbgrid6;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, PropSaveMain, PropSaveGrids, DB, Buttons,
  Grids, DBGrids, rDBGrid, ComCtrls, DBCtrls, rHTMLLabel;

type
  TrDBGrid6 = class(TForm)
    lblInfo: TrHTMLLabel;
    DBNavigator1: TDBNavigator;
    PropSaveMain1: TPropSaveMain;
    rDBGridsPropSave1: TrDBGridsPropSave;
    pc: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    gr51: TrDBGrid;
    grSum1: TrDBGrid;
    gr53: TrDBGrid;
    grSum3: TrDBGrid;
    gr52: TrDBGrid;
    grSum2: TrDBGrid;
    FormatLabel1: TrHTMLLabel;
    FormatLabel2: TrHTMLLabel;
    FormatLabel3: TrHTMLLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure grSum2GetCellParams(Sender: TObject; Field: TField; AFont: TFont; var Background: TColor; ActiveRow, Highlight: Boolean);
    procedure AfterUpdate(DataSet: TDataSet);
    procedure gr51GetHintStringEx(Sender: TObject; UnderMouseColumn: TColumn;
      TitleRow, FooterRow: Boolean; FieldValues: TStrings; CellText: string;
      var HintString: string);
    procedure grSum1GetHintStringEx(Sender: TObject; UnderMouseColumn: TColumn;
      TitleRow, FooterRow: Boolean; FieldValues: TStrings; CellText: string;
      var HintString: string);
    procedure gr52GetHintStringEx(Sender: TObject; UnderMouseColumn: TColumn;
      TitleRow, FooterRow: Boolean; FieldValues: TStrings; CellText: string;
      var HintString: string);
    procedure grSum2GetHintStringEx(Sender: TObject; UnderMouseColumn: TColumn;
      TitleRow, FooterRow: Boolean; FieldValues: TStrings; CellText: string;
      var HintString: string);
    procedure gr53GetHintStringEx(Sender: TObject; UnderMouseColumn: TColumn;
      TitleRow, FooterRow: Boolean; FieldValues: TStrings; CellText: string;
      var HintString: string);
  private
  public
  end;

var
  rDBGrid6: TrDBGrid6;

implementation

uses dm_data, f_main, rDBGrid_DTEdit, rdlg, rdbtool;
{$R *.dfm}

procedure TrDBGrid6.FormShow(Sender: TObject);
begin
  // link master grids and summary grids
  gr51.SetFooterDBGrid(grSum1, '', false, true);
  gr52.SetFooterDBGrid(grSum2, '', false, true);
  gr53.SetFooterDBGrid(grSum3, 'SumOf', false, true);

  DMData.qEmp.Close;
  DMData.qEmp.Open;
  DMData.AfterUpdate:=AfterUpdate;
  AfterUpdate(nil);
end;

procedure TrDBGrid6.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DMData.qEmp.Close;
  DMData.AfterUpdate:=nil;
end;

procedure TrDBGrid6.AfterUpdate(DataSet: TDataSet);
begin
  // refresh summary datasets after post = after change of master dataset
  DMData.qEmpSum1.Close;
  DMData.qEmpSum1.Open;
  DMData.qEmpSum2.Close;
  DMData.qEmpSum2.Open;
  DMData.qEmpSum3.Close;
  DMData.qEmpSum3.Open;
end;

procedure TrDBGrid6.gr51GetHintStringEx(Sender: TObject;
  UnderMouseColumn: TColumn; TitleRow, FooterRow: Boolean;
  FieldValues: TStrings; CellText: string; var HintString: string);
begin
  if Assigned(UnderMouseColumn) and (UnderMouseColumn.Field=DMData.qEmpPartTime) then
  begin
    if SameText(CellText, 'yes') or SameText(CellText, '1') then
      HintString:='PartTime'
    else
      HintString:='FullTime';
  end;
end;

procedure TrDBGrid6.grSum1GetHintStringEx(Sender: TObject;
  UnderMouseColumn: TColumn; TitleRow, FooterRow: Boolean;
  FieldValues: TStrings; CellText: string; var HintString: string);
begin
  if Assigned(UnderMouseColumn) and Assigned(UnderMouseColumn.Field) then
    HintString:=UnderMouseColumn.Field.DisplayLabel;
end;

procedure TrDBGrid6.gr52GetHintStringEx(Sender: TObject;
  UnderMouseColumn: TColumn; TitleRow, FooterRow: Boolean;
  FieldValues: TStrings; CellText: string; var HintString: string);
begin
  // set hint for BirthDate
  if Assigned(UnderMouseColumn) and (UnderMouseColumn.Field=DMData.qEmpBirthDate) and (CellText <> '') then
    try
      HintString:='Age: ' + IntToStr(Round((Date - StrToDate(CellText)) / 365)) + ' years';
    except
    end;
  if Assigned(UnderMouseColumn) and (UnderMouseColumn.Field=DMData.qEmpHireDate) and (CellText <> '') then
    try
      HintString:='Contract length: ' + IntToStr(Round((Date - StrToDate(CellText)) / 30)) + ' months';
    except
    end;
end;

procedure TrDBGrid6.grSum2GetHintStringEx(Sender: TObject;
  UnderMouseColumn: TColumn; TitleRow, FooterRow: Boolean;
  FieldValues: TStrings; CellText: string; var HintString: string);
begin
  if Assigned(UnderMouseColumn) and Assigned(UnderMouseColumn.Field) then
    HintString:=FieldValues.Values['EmployeeID'] + ' ' + UnderMouseColumn.Field.DisplayLabel;
end;

procedure TrDBGrid6.grSum2GetCellParams(Sender: TObject; Field: TField; AFont: TFont; var Background: TColor; ActiveRow, Highlight: Boolean);
begin
  // select font for All: record
  if SameText(DMData.qEmpSum2EmployeeID.AsString, 'All:') then
    AFont.Style:=AFont.Style + [fsBold];
end;

procedure TrDBGrid6.gr53GetHintStringEx(Sender: TObject;
  UnderMouseColumn: TColumn; TitleRow, FooterRow: Boolean;
  FieldValues: TStrings; CellText: string; var HintString: string);
begin
  // set hint for field Country according EmployeeID
  if Assigned(UnderMouseColumn) and (UnderMouseColumn.Field=DMData.qEmpCountry) and (CellText <> '') then
    try
      // lookup record in table according EmpID (in this case in same table, but can be any table
      DMData.SetQueryParam(DMData.qEmpAdr,'EmployeeID',FieldValues.Values['EmployeeID']);
      DMData.qEmpAdr.Open;
      HintString:='Address: ' + DMData.qEmpAdrAddr.AsString;
      DMData.qEmpAdr.Close;
    except
    end;
end;

end.
