unit f_rdbgrid_ms;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, PropSaveMain, PropSaveGrids, DB, StdCtrls,
  rHTMLLabel, Grids, DBGrids, rDBGrid, rDBGrid_MS, DBCtrls;

type
  TrDBGridMS = class(TForm)
    DBNavigator1: TDBNavigator;
    grMS: TrDBGrid_MS;
    lblInfo: TrHTMLLabel;
    PropSaveMain1: TPropSaveMain;
    rDBGridsPropSave1: TrDBGridsPropSave;
    gbOpt: TGroupBox;
    ch11: TCheckBox;
    ch12: TCheckBox;
    ch21: TCheckBox;
    clSelRowBk: TColorBox;
    clSelRowFont: TColorBox;
    Label2: TLabel;
    btSelectAll: TrURLLabel;
    btDeselectAll: TrURLLabel;
    btReverseSel: TrURLLabel;
    btGetRecCount: TButton;
    btProcSelRec: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ch11Click(Sender: TObject);
    procedure ch12Click(Sender: TObject);
    procedure ch21Click(Sender: TObject);
    procedure clSelRowBkChange(Sender: TObject);
    procedure btSelectAllClick(Sender: TObject);
    procedure btDeselectAllClick(Sender: TObject);
    procedure btReverseSelClick(Sender: TObject);
    procedure btGetRecCountClick(Sender: TObject);
    procedure btProcSelRecClick(Sender: TObject);
    procedure grMSFilterChanged(Sender: TObject);
  private
    s: string;
    procedure SelectedCallBack(Sender: TObject);
  public
  end;

var
  rDBGridMS: TrDBGridMS;

implementation

uses dm_data, f_main, rDBGrid_DTEdit, rdlg;
{$R *.dfm}

procedure TrDBGridMS.FormShow(Sender: TObject);
begin
  DMData.qProducts.Close;
  DMData.qProducts.Open;
  grMS.Resort;
end;

procedure TrDBGridMS.grMSFilterChanged(Sender: TObject);
begin
  beep;
end;

procedure TrDBGridMS.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DMData.qProducts.Close;
end;

procedure TrDBGridMS.ch11Click(Sender: TObject);
begin
  grMS.SelectByClickOnRow:=ch11.Checked;
end;

procedure TrDBGridMS.ch12Click(Sender: TObject);
begin
  if ch12.Checked then
    grMS.FixedColText.ShowCheckbox:=true
  else
    grMS.FixedColText.ShowCheckbox:=false;
end;

procedure TrDBGridMS.ch21Click(Sender: TObject);
begin
  grMS.OptionsEx2.Appearance.HighlightMultiselect:=not ch21.Checked;
end;

procedure TrDBGridMS.clSelRowBkChange(Sender: TObject);
begin
  grMS.SelectedRowsBkColor:=clSelRowBk.Selected;
  grMS.SelectedRowsFontColor:=clSelRowFont.Selected;
  grMS.Invalidate;
end;

procedure TrDBGridMS.btSelectAllClick(Sender: TObject);
begin
  grMS.SelectAll;
end;

procedure TrDBGridMS.btDeselectAllClick(Sender: TObject);
begin
  grMS.DeSelectAll;
end;

procedure TrDBGridMS.btReverseSelClick(Sender: TObject);
begin
  grMS.ReverseSelection;
end;

procedure TrDBGridMS.btGetRecCountClick(Sender: TObject);
begin
  ShowMessage(IntToStr(grMS.GetSelectedRecCount));
end;

procedure TrDBGridMS.btProcSelRecClick(Sender: TObject);
var
  i: integer;
begin
  // standard way
  s:='';
  for i:=0 to grMS.rBookmarks.Count - 1 do
  begin
    grMS.Datasource.Dataset.GotoBookmark(grMS.rBookmarks[i]);
    s:=s + grMS.Datasource.Dataset.Fields[1].AsString + '; ';
  end;
  ShowMessage('Selected records by rBookmarks: ' + #13#10 + s);

  // callback procedure way
  s:='';
  grMS.ProcScopeRecords(rsSelectedRecOnly, SelectedCallBack);
  ShowMessage('Selected records by Callback: ' + #13#10 + s);
end;

procedure TrDBGridMS.SelectedCallBack(Sender: TObject);
begin
  s:=s + grMS.Datasource.Dataset.Fields[1].AsString + '; ';
end;

end.
