unit f_rdbrecview;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PropSaveMain, DB, DBCtrls, StdCtrls, ExtCtrls, Grids, DBGrids,
  rDBRecView, rImprovedComps, rDBComponents, rHTMLLabel, PropSaveGrids;

type
  TrDBRecViewTest = class(TForm)
    lblInfo: TrHTMLLabel;
    PropSaveMain1: TPropSaveMain;
    GroupBox7: TGroupBox;
    rDBMoveButton5: TrDBMoveButton;
    rDBMoveButton6: TrDBMoveButton;
    rDBMoveButton7: TrDBMoveButton;
    rDBMoveButton8: TrDBMoveButton;
    rDBRecView: TrDBRecView;
    Panel2: TPanel;
    cbOV: TCheckBox;
    cbOS: TCheckBox;
    cbAH: TCheckBox;
    DBNavigator1: TDBNavigator;
    rDBGridsPropSave1: TrDBGridsPropSave;
    btPrint: TButton;
    btPrintDirect: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lblInfoAnchorClick(Sender: TObject; LinkName: String);
    procedure cbOVClick(Sender: TObject);
    procedure cbOSClick(Sender: TObject);
    procedure cbAHClick(Sender: TObject);
    procedure btPrintClick(Sender: TObject);
    procedure btPrintDirectClick(Sender: TObject);
    procedure rDBRecViewLinkClick(Sender: TObject; DataSet: TDataSet;
      Column: TColumn; Field: TField; Value: Variant);
    procedure rDBRecViewEditButtonClick(Sender: TObject);
  private
  public
  end;

var
  rDBRecViewTest: TrDBRecViewTest;

implementation

uses dm_data, f_main, rDBRecView_DTEdit, rstring, rdlg, rdbtool,
  rDBRecViewFields, rDBPrint, rDBPrintDirect;
{$R *.dfm}

procedure TrDBRecViewTest.FormShow(Sender: TObject);
begin
  DMData.qEmp.Close;
  DMData.qEmp.Open;
end;

procedure TrDBRecViewTest.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DMData.qEmp.Close;
end;

procedure TrDBRecViewTest.lblInfoAnchorClick(Sender: TObject; LinkName: String);
begin
  if LinkName = 'DTEdit' then
  begin
    rDBRecView_DTEdit.ShowrDBRecViewEditor(rDBRecView);
    rDBRecView.Invalidate;
  end
  else
    rDBRecViewFields.ChooseRecViewFields(rDBRecView);
end;

procedure TrDBRecViewTest.rDBRecViewEditButtonClick(Sender: TObject);
begin
  DlgI('Edit button clicked');
end;

procedure TrDBRecViewTest.rDBRecViewLinkClick(Sender: TObject;
  DataSet: TDataSet; Column: TColumn; Field: TField; Value: Variant);
begin
  DlgI2('Link clicked', Value);
end;

procedure TrDBRecViewTest.cbOVClick(Sender: TObject);
begin
  rDBRecView.OnlyVisibleField:=cbOV.Checked;
end;

procedure TrDBRecViewTest.cbOSClick(Sender: TObject);
begin
  rDBRecView.OnlySimpleField:=cbOS.Checked;
end;

procedure TrDBRecViewTest.btPrintClick(Sender: TObject);
begin
  rDBPrint.DBPrint(rDBRecView, 'Test title');
end;

procedure TrDBRecViewTest.btPrintDirectClick(Sender: TObject);
begin
  rDBPrintDirect.DBPrintDirect(rDBRecView, 'Test title');
end;

procedure TrDBRecViewTest.cbAHClick(Sender: TObject);
begin
  if cbAH.Checked then
    rDBRecView.OptionsEx:=rDBRecView.OptionsEx + [goAutoHeight]
  else
    rDBRecView.OptionsEx:=rDBRecView.OptionsEx - [goAutoHeight];
end;

end.
