unit f_reportcomps;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DB, PropSaveMain,
  PropSaveGrids, StdCtrls, Buttons, Grids, DBGrids, rDBGrid, ComCtrls,
  rHTMLLabel, DBCtrls, rDBComponents, rXMLReport, RTFReport2;

type
  TReportComps = class(TForm)
    lblInfo: TrHTMLLabel;
    PropSaveMain1: TPropSaveMain;
    rDBGridsPropSave1: TrDBGridsPropSave;
    pc: TPageControl;
    TabSheet1: TTabSheet;
    grEmp: TrDBGrid;
    TabSheet3: TTabSheet;
    grOrder: TrDBGrid;
    grCustList: TrDBGrid;
    RTFRep: TRTFReport2;
    grItems: TrDBGrid;
    TabSheet4: TTabSheet;
    BitBtn12: TBitBtn;
    XMLRep: TrXMLReport;
    GroupBox5: TGroupBox;
    btList: TBitBtn;
    btPhoto: TBitBtn;
    btPrintDlg: TBitBtn;
    btMD: TBitBtn;
    rgType: TRadioGroup;
    rgScope: TRadioGroup;
    btPrintDirect: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RTFRepReportProcess(Sender: TObject; RecNbr: Integer; var Abort: Boolean);
    procedure btPhotoClick(Sender: TObject);
    procedure btPrintDlgClick(Sender: TObject);
    procedure btMDClick(Sender: TObject);
    procedure BitBtn12Click(Sender: TObject);
    procedure btListClick(Sender: TObject);
    procedure RTFRepReadInfo(Sender: TObject);
    procedure btPrintDirectClick(Sender: TObject);
  private
    procedure DefVariables(L: TStrings);
    procedure RepBeforeEdit(Sender: TObject);
    procedure CheckDll;
  public
  end;

var
  ReportComps: TReportComps;

implementation

uses dm_data, f_main, rDBGrid_DTEdit, rstring, rdlg, rtip, rtool, rdbtool,
  rDBExport, rDBPrint, rDBPrintDirect, RTFRep_DialogEx, rDBFilter;
{$R *.dfm}

procedure TReportComps.FormShow(Sender: TObject);
begin
  DMData.qEmp.Close;
  DMData.qOrderDetails.Close;
  DMData.qOrders.Close;
  DMData.qCust.Close;
  DMData.qEmp.Open;
  DMData.qOrderDetails.Open;
  DMData.qOrders.Open;
  DMData.qCust.Open;
end;

procedure TReportComps.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DMData.qEmp.Close;
  DMData.qOrderDetails.Close;
  DMData.qOrders.Close;
  DMData.qCust.Close;
end;

procedure TReportComps.DefVariables(L: TStrings);
begin
  L.Clear;
  L.Add('Header=Any header text');
  L.Add('Footer=Any footer text');
end;

procedure TReportComps.RTFRepReadInfo(Sender: TObject);
var
  s: string;
begin
  // Show any warning from report template or proccess it
  if Sender is TRTFReport2 then
  begin
    s:=(Sender as TRTFReport2).ExtendedInfo.Values['showtext'];
    if s <> '' then
      DlgI(s);
    s:=(Sender as TRTFReport2).ExtendedInfo.Values['printer'];
    if s <> '' then
      DlgI('App should set printer to: ' + s);
  end;
end;

procedure TReportComps.RTFRepReportProcess(Sender: TObject; RecNbr: Integer; var Abort: Boolean);
begin
  if (RecNbr mod 10) = 0 then
    ShowInfo(Format('Report is creating... record %d', [RecNbr]), Self);
end;

procedure TReportComps.CheckDll;
begin
  if not FileExists(GetAppDir + 'rzip.dll') then
  begin
    rtip.ShowTip('<B>DOCX and ODT report needs rzip.dll library</B> to unzip and zip file.<BR><BR>' +
        'Download rzip.dll from <a href=http://www.rosinsky.cz/delphi/xmlreport_help.html>my pages</a> and copy to demo directory.', '', nil);
    Abort;
  end;
end;

procedure TReportComps.btListClick(Sender: TObject);
begin
  if (rgType.ItemIndex > 0) then
    CheckDll;
  try
    case rgType.ItemIndex of
      0:
        begin
          RTFRep.ReportFile:=GetAppDir + 'Reports\Employee_list.rtf';
          RTFRep.OutputFile:=GetAppDir + 'Output\Report.rtf';
          DefVariables(RTFRep.Variables);
          RTFRep.Execute([DMData.qEmp]);
        end;
      1:
        begin
          XMLRep.ReportFile:=GetAppDir + 'Reports\Employee_list.docx';
          XMLRep.OutputFile:=GetAppDir + 'Output\Report.docx';
          DefVariables(XMLRep.Variables);
          XMLRep.Execute([DMData.qEmp]);
        end;
      2:
        begin
          XMLRep.ReportFile:=GetAppDir + 'Reports\Employee_list.odt';
          XMLRep.OutputFile:=GetAppDir + 'Output\Report.odt';
          DefVariables(XMLRep.Variables);
          XMLRep.Execute([DMData.qEmp]);
        end;
    end;
  finally
    ShowInfo('', Self);
  end;
end;

procedure TReportComps.btPhotoClick(Sender: TObject);
begin
  if (rgType.ItemIndex > 0) then
    CheckDll;
  try
    case rgType.ItemIndex of
      0:
        begin
          RTFRep.ReportFile:=GetAppDir + 'Reports\Employee_photocards.rtf';
          RTFRep.OutputFile:=GetAppDir + 'Output\Report.rtf';
          DefVariables(RTFRep.Variables);
          RTFRep.Execute([DMData.qEmp]);
        end;
      1:
        begin
          XMLRep.ReportFile:=GetAppDir + 'Reports\Employee_photocards.docx';
          XMLRep.OutputFile:=GetAppDir + 'Output\Report.docx';
          DefVariables(XMLRep.Variables);
          XMLRep.Execute([DMData.qEmp]);
        end;
      2:
        begin
          XMLRep.ReportFile:=GetAppDir + 'Reports\Employee_photocards.odt';
          XMLRep.OutputFile:=GetAppDir + 'Output\Report.odt';
          DefVariables(XMLRep.Variables);
          XMLRep.Execute([DMData.qEmp]);
        end;
    end;
  finally
    ShowInfo('', Self);
  end;
end;

procedure TReportComps.btMDClick(Sender: TObject);
begin
  if (rgType.ItemIndex > 0) then
    CheckDll;
  if rgScope.ItemIndex = 0 then
    rDBFilter.FilterByField(DMData.qCustCustomerID)
  else
    rDBFilter.ClearFilter(DMData.qCust);
  try
    case rgType.ItemIndex of
      0:
        begin
          RTFRep.ReportFile:=GetAppDir + 'Reports\Master_detail.rtf';
          RTFRep.OutputFile:=GetAppDir + 'Output\Report.rtf';
          DefVariables(RTFRep.Variables);
          RTFRep.Execute([DMData.qCust, DMData.qOrders, DMData.qOrderDetails]);
        end;
      1:
        begin
          XMLRep.ReportFile:=GetAppDir + 'Reports\Master_detail.docx';
          XMLRep.OutputFile:=GetAppDir + 'Output\Report.docx';
          DefVariables(XMLRep.Variables);
          XMLRep.Execute([DMData.qCust, DMData.qOrders, DMData.qOrderDetails]);
        end;
      2:
        begin
          XMLRep.ReportFile:=GetAppDir + 'Reports\Master_detail.odt';
          XMLRep.OutputFile:=GetAppDir + 'Output\Report.odt';
          DefVariables(XMLRep.Variables);
          XMLRep.Execute([DMData.qCust, DMData.qOrders, DMData.qOrderDetails]);
        end;
    end;
  finally
    rDBFilter.ClearFilter(DMData.qCust);
    ShowInfo('', Self);
  end;
end;

procedure TReportComps.btPrintDlgClick(Sender: TObject);
begin
  rDBPrint.DBPrint(grEmp, true, true, 'Any caption');
end;

procedure TReportComps.btPrintDirectClick(Sender: TObject);
begin
  rDBPrintDirect.DBPrintDirect(grEmp, true, true, 'Any caption');
end;

procedure TReportComps.RepBeforeEdit(Sender: TObject);
begin
  DlgI('Show any warning or help before edit of template.');
end;

procedure TReportComps.BitBtn12Click(Sender: TObject);
var
  r1, r2, r3: TRTFRepInfoEx;
  d: TRTFRepDlgInfoClass;
begin
  // set report 1
  SetRTFRepInfo(r1, 'Simple report', 'Employees report', 'Any <B>html</B> formated information about report...<BR><COLOR=Gray>Any type of text and colors',
    GetAppDir + 'Reports\Employee_list.rtf', GetAppDir + 'Output\Report.rtf', [DMData.qEmp]);
  ClearRTFRepVariableEx(r1);
  AddRTFRepVariableEx(r1, 'Header=Any header text');
  AddRTFRepVariableEx(r1, 'Footer=Any footer text');

  // set report 2
  SetRTFRepInfo(r2, '', 'Master detail report', 'List of customers and orders', GetAppDir + 'Reports\Master_detail.rtf', GetAppDir + 'Output\Report.rtf',
    [DMData.qCust, DMData.qOrders, DMData.qOrderDetails]);
  ClearRTFRepVariableEx(r2);
  AddRTFRepVariableEx(r2, 'Header=Any header text');
  AddRTFRepVariableEx(r2, 'Footer=Any footer text');

  // set report 3
  SetRTFRepInfo(r3, 'Simple report', 'Employees photo cards', 'List of visiting card of employees', GetAppDir + 'Reports\Employee_photocards.rtf',
    GetAppDir + 'Output\Report.rtf', [DMData.qEmp]);
  ClearRTFRepVariableEx(r3);
  AddRTFRepVariableEx(r3, 'Header=Any header text');
  AddRTFRepVariableEx(r3, 'Footer=Any footer text');

  // set report dialog props
  d:=TRTFRepDlgInfoClass.Create;
  try
    d.ShowMailBtn:=true;
    d.UseMapi:=true;
    d.MailTo:='test@rosinsky.cz';
    d.OnBeforeEdit:=RepBeforeEdit;
    d.OnReadInfo:=RTFRepReadInfo;
    d.AutoAction:=daaNone;
    d.ShowPDFBtn:=false;
    // Open dialog
    ShowRTFRepDialogEx([r1, r2, r3], d);
  finally
    d.Free;
  end;
end;

end.
